<?php

if (!defined('BASEPATH'))
    exit('No direct script access allowed');

class Collaborator extends MX_Controller {

    const TOKENPW = 'violet';

    public function __construct() {
        parent::__construct();
        $this->load->helper('cookie');
		$this->load->helper('language');
		$this->lang->load('messages', 'message');
    }
	
	public function profile(){
		$collaborator_info = $this->session->userdata('collaboratorInfo');
        if ($collaborator_info) {
			$data['collaborator_id'] = $collaborator_info['id'];
			$data['username'] = $collaborator_info['login_name'];
			$data['fullname'] = $collaborator_info['fullname'];
			$this->load->view('collaborator/collaborator_profile', $data);
		}else{
			$this->load->view('login');
		}
	}
	
	public function updateCollaborator(){
		$this->load->model('collaborator_model');
		$collaborator_info = $this->session->userdata('collaboratorInfo');
		$result['success'] = 0;
        if ($collaborator_info) {
			
			$collaborator_id = $collaborator_info['id'];
			$login_name = $collaborator_info['login_name'];
			$input = $this->input->post();
			if (strlen($input['fullname']) == 0) {
				$result['errors'][] = array("content"=>lang('_SBG_FULLNAME_REQUIRED_MSG'),"field"=>"fullname_err");
			}
			if (!isset($result['errors'])) {
				$collaborator = array('full_name' => $input['fullname']);
				$result['success'] = 1;
				$result['data'] = $this->collaborator_model->updateCollaborator($collaborator_id, $collaborator);
                $collaboratorData = array('login_name' => $login_name, 'id' => $collaborator_id, 'fullname' => $input['fullname'], 'logined_in' => TRUE);
                $this->session->set_userdata('collaboratorInfo', $collaboratorData);
			}
			echo json_encode($result);
		}else{
			$this->load->view('login');
		}
	}
	
	public function change_password(){
		$this->load->model('collaborator_model');
		$collaborator_info = $this->session->userdata('collaboratorInfo');
        if ($collaborator_info) {
			$collaborator_id = (int)$collaborator_info['id'];
			$input = $this->input->post();
            if (strlen($input['passwd']) == 0) {
                $result['errors']['passwd_old_err'] = lang('_SBG_PASSWORD_REQUIRED_MSG');
            }
			
            if (strlen($input['passwd_new']) == 0) {
                $result['errors']['passwd_new_err'] = lang('_SBG_PASSWORD_REQUIRED_MSG');
            } else if (strcmp($input['passwd'], $input['passwd_new']) == 0) {
                $result['errors']['passwd_new_err'] = lang('_SBG_PASSWORD_DUPLICATE_MSG');
            }else
			{
				if (!preg_match('/^([0-9a-zA-Z]{6,65})*$/', $input['passwd_new']))
				{
					$result['errors']['passwd_new_err'] = lang('_SBG_USER_PASSWORD_CHANGE_REQUIRED_MSG');
				}
			}
			
            if ($input['passwd_new'] != $input['confirm_passwd_new']) {
                $result['errors']['confirm_passwd_new_err'] = lang('_SBG_PASSWORD_CONFIRM_MSG');
            }
			$passwd = $input['passwd'];
			$checkPass = $this->collaborator_model->checkPassCollaborator($collaborator_id, $passwd);
			if ($checkPass == false){
				 $result['errors']['passwd_old_err'] = lang('_SBG_OLD_PASSWORD_FAIL_MSG');
			}
	
			if (!isset($result['errors'])) {
				$collaborator = array('passwd'=>md5($input['passwd_new']));
				$check = $this->collaborator_model->updateCollaborator($collaborator_id, $collaborator);
				if ($check){
					$result['success'] = 1;
				}else{
					$result['success'] = 0;
				}
			}
			echo json_encode($result);
			
		}else{
			$this->load->view('login');
		}
	}
}
